/*
 * Character.h
 *
 *  Created on: 18/mar/2013
 *      Author: utente
 */

#ifndef CHARACTER_H_
#define CHARACTER_H_

#include <string>
#include "Weapon.h"
#include <iostream>

class Character {
public:
	Character(int hp, int a = 6, int d = 6);
	Character(std::string n, int hp, int a = 6, int d = 6);
	~Character() { numChar--; }
	int fight(Character& enemy);
	void move(int x, int y);
	int getArmor() const {
		return armor;
	}
	int getHP() const {
		return HP;
	}
	Weapon* getWeapon() const {
		return weapon;
	}
	void setArmor(int armor) {
		this->armor = armor;
	}
	void setHP(int HP) {
		this->HP = HP;
	}
	void setWeapon(Weapon* weapon) {
		this->weapon = weapon;
	}
	int getDexterity() const {
		return dexterity;
	}
	void setDexterity(int dexterity) {
		this->dexterity = dexterity;
	}
	static int getNumChar() { // makes sense to have it as class method
		return numChar;
	}
	int getN() {  // not really meaningful... just to compare its use with static method
		return numChar;
	}
	friend std::ostream&  operator<<(std::ostream& os, Character& c); // friend function

private:
	std::string name;
	int HP;
	int dexterity;
	int armor;
	Weapon* weapon;
	int posX, posY;
	static int numChar;
};

#endif /* CHARACTER_H_ */
